Index: branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution-3.3.csproj
===================================================================
--- branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution-3.3.csproj	(revision 10039)
+++ branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution-3.3.csproj	(revision 10232)
@@ -41,5 +41,5 @@
     <RunPostBuildEvent>OnBuildSuccess</RunPostBuildEvent>
     <AllowUnsafeBlocks>False</AllowUnsafeBlocks>
-    <NoStdLib>False</NoStdLib>
+    <NoStdLib>True</NoStdLib>
     <TreatWarningsAsErrors>False</TreatWarningsAsErrors>
     <IntermediateOutputPath>obj\$(Configuration)\</IntermediateOutputPath>
@@ -99,4 +99,15 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="ALGLIB-3.7.0, Version=3.7.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=x86">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\trunk\sources\bin\ALGLIB-3.7.0.dll</HintPath>
+    </Reference>
+    <Reference Include="AutoDiff-1.0, Version=1.0.0.14388, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=x86">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\trunk\sources\bin\AutoDiff-1.0.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Analysis-3.3">
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Analysis-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.Collections-3.3">
       <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Collections-3.3.dll</HintPath>
@@ -107,4 +118,7 @@
       <Private>False</Private>
     </Reference>
+    <Reference Include="HeuristicLab.Common.Resources-3.3">
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Common.Resources-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.Core-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <SpecificVersion>False</SpecificVersion>
@@ -151,7 +165,20 @@
       <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Problems.ArtificialAnt-3.4.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.Problems.DataAnalysis-3.4">
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Problems.DataAnalysis-3.4.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Problems.DataAnalysis.Symbolic-3.4">
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Problems.DataAnalysis.Symbolic.Regression-3.4">
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Problems.DataAnalysis.Symbolic.Regression-3.4.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Problems.Instances-3.3">
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Problems.Instances-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.Random-3.3">
       <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Random-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="mscorlib" />
     <Reference Include="System" />
     <Reference Include="System.Core">
@@ -171,7 +198,24 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="Symbolic\GESymbolicDataAnalysisEvaluator.cs" />
+    <Compile Include="Symbolic\GESymbolicDataAnalysisProblem.cs" />
+    <Compile Include="Symbolic\GESymbolicDataAnalysisSingleObjectiveEvaluator.cs" />
+    <Compile Include="Symbolic\GESymbolicDataAnalysisSingleObjectiveProblem.cs" />
+    <Compile Include="Symbolic\GESymbolicRegressionConstantOptimizationEvaluator.cs" />
+    <Compile Include="Symbolic\GESymbolicRegressionSingleObjectiveEvaluator.cs" />
+    <Compile Include="Symbolic\GESymbolicRegressionSingleObjectiveMaxAbsoluteErrorEvaluator.cs" />
+    <Compile Include="Symbolic\GESymbolicRegressionSingleObjectiveMeanAbsoluteErrorEvaluator.cs" />
+    <Compile Include="Symbolic\GESymbolicRegressionSingleObjectiveMeanSquaredErrorEvaluator.cs" />
+    <Compile Include="Symbolic\GESymbolicRegressionSingleObjectivePearsonRSquaredEvaluator.cs" />
+    <Compile Include="Symbolic\GESymbolicRegressionSingleObjectiveProblem.cs" />
+    <Compile Include="Symbolic\IGESymbolicDataAnalysisEvaluator.cs" />
+    <Compile Include="Symbolic\IGESymbolicDataAnalysisProblem.cs" />
+    <Compile Include="Symbolic\IGESymbolicDataAnalysisSingleObjectiveEvaluator.cs" />
+    <Compile Include="Symbolic\IGESymbolicDataAnalysisValidationAnalyzer.cs" />
+    <Compile Include="Symbolic\IGESymbolicRegressionEvaluator.cs" />
+    <Compile Include="Symbolic\IGESymbolicRegressionSingleObjectiveEvaluator.cs" />
     <None Include="HeuristicLab.snk" />
-    <Compile Include="GEArtificialAntEvaluator.cs" />
-    <Compile Include="GEArtificialAntProblem.cs" />
+    <Compile Include="ArtificialAnt\GEArtificialAntEvaluator.cs" />
+    <Compile Include="ArtificialAnt\GEArtificialAntProblem.cs" />
     <Compile Include="Mappers\BreathFirstMapper.cs" />
     <Compile Include="Mappers\DepthFirstMapper.cs" />
@@ -202,7 +246,5 @@
     </BootstrapperPackage>
   </ItemGroup>
-  <ItemGroup>
-    <Folder Include="Mappers" />
-  </ItemGroup>
+  <ItemGroup />
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
@@ -229,5 +271,5 @@
   <PropertyGroup Condition=" '$(Platform)' == 'AnyCPU' ">
     <BaseAddress>4194304</BaseAddress>
-    <PlatformTarget>x86</PlatformTarget>
+    <PlatformTarget>AnyCPU</PlatformTarget>
     <RegisterForComInterop>False</RegisterForComInterop>
     <GenerateSerializationAssemblies>Auto</GenerateSerializationAssemblies>