Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/FilterContent.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/FilterContent.cs	(revision 10244)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/FilterContent.cs	(revision 10245)
@@ -1,5 +1,7 @@
-﻿using HeuristicLab.Core;
+﻿using HeuristicLab.Common;
+using HeuristicLab.Core;
 using System;
 using System.Collections.Generic;
+using System.Drawing;
 using System.Linq;
 using System.Text;
@@ -8,6 +10,23 @@
 {
   [Item("FilterContent", "Represents the filter grid.")]
-  class FilterContent : IItem
+  class FilterContent : Item
   {
+
+    public FilterContent(FilterContent content, Cloner cloner)
+      : base(content, cloner)
+    {
+
+    }
+
+    public static new Image StaticItemImage
+    {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Table; }
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner)
+    {
+      return new FilterContent(this, cloner);
+    }
+
   }
 }
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/HistogramContent.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/HistogramContent.cs	(revision 10244)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/HistogramContent.cs	(revision 10245)
@@ -1,5 +1,8 @@
-﻿using HeuristicLab.Core;
+﻿using HeuristicLab.Common;
+using HeuristicLab.Core;
+using System.Drawing;
 using System;
 using System.Collections.Generic;
+
 using System.Linq;
 using System.Text;
@@ -8,6 +11,21 @@
 {
   [Item("HistogramContent", "Represents the histogram grid.")]
-  class HistogramContent : IItem
+  class HistogramContent : Item
   {
+    public HistogramContent(HistogramContent content, Cloner cloner)
+      : base(content, cloner)
+    {
+
+    }
+
+    public static new Image StaticItemImage
+    {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Table; }
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner)
+    {
+      return new HistogramContent(this, cloner);
+    }
   }
 }
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/LineChartContent.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/LineChartContent.cs	(revision 10244)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/LineChartContent.cs	(revision 10245)
@@ -1,3 +1,5 @@
-﻿using HeuristicLab.Core;
+﻿using HeuristicLab.Common;
+using HeuristicLab.Core;
+using System.Drawing;
 using System;
 using System.Collections.Generic;
@@ -8,6 +10,21 @@
 {
   [Item("LineChartContent", "Represents the line chart grid.")]
-  class LineChartContent : IItem
+  class LineChartContent : Item
   {
+    public LineChartContent(LineChartContent content, Cloner cloner)
+      : base(content, cloner)
+    {
+
+    }
+
+    public static new Image StaticItemImage
+    {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Table; }
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner)
+    {
+      return new LineChartContent(this, cloner);
+    }
   }
 }
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/StatisticsContent.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/StatisticsContent.cs	(revision 10244)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/StatisticsContent.cs	(revision 10245)
@@ -1,3 +1,5 @@
-﻿using HeuristicLab.Core;
+﻿using HeuristicLab.Common;
+using HeuristicLab.Core;
+using System.Drawing;
 using System;
 using System.Collections.Generic;
@@ -8,6 +10,21 @@
 {
   [Item("StatisticsContent", "Represents the statistics grid.")]
-  class StatisticsContent : IItem
+  class StatisticsContent : Item
   {
+    public StatisticsContent(StatisticsContent content, Cloner cloner)
+      : base(content, cloner)
+    {
+
+    }
+
+    public static new Image StaticItemImage
+    {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Table; }
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner)
+    {
+      return new StatisticsContent(this, cloner);
+    }
   }
 }
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/TransformationContent.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/TransformationContent.cs	(revision 10244)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/TransformationContent.cs	(revision 10245)
@@ -1,3 +1,5 @@
-﻿using HeuristicLab.Core;
+﻿using HeuristicLab.Common;
+using HeuristicLab.Core;
+using System.Drawing;
 using System;
 using System.Collections.Generic;
@@ -8,6 +10,21 @@
 {
   [Item("TransformationContent", "Represents the transformation grid.")]
-  class TransformationContent : IItem
+  class TransformationContent : Item
   {
+    public TransformationContent(TransformationContent content, Cloner cloner)
+      : base(content, cloner)
+    {
+
+    }
+
+    public static new Image StaticItemImage
+    {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Table; }
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner)
+    {
+      return new TransformationContent(this, cloner);
+    }
   }
 }