Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/DataPreprocessingView.designer.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/DataPreprocessingView.designer.cs	(revision 10239)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/DataPreprocessingView.designer.cs	(revision 10247)
@@ -25,6 +25,7 @@
     private void InitializeComponent() {
       this.splitContainer1 = new System.Windows.Forms.SplitContainer();
-      this.listView1 = new System.Windows.Forms.ListView();
-      this.groupBox1 = new System.Windows.Forms.GroupBox();
+      this.contentListView = new System.Windows.Forms.ListView();
+      this.tryOutAlgorithmButton = new System.Windows.Forms.Button();
+      this.saveButton = new System.Windows.Forms.Button();
       this.viewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer1)).BeginInit();
@@ -32,5 +33,4 @@
       this.splitContainer1.Panel2.SuspendLayout();
       this.splitContainer1.SuspendLayout();
-      this.groupBox1.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -43,34 +43,46 @@
       // splitContainer1.Panel1
       // 
-      this.splitContainer1.Panel1.Controls.Add(this.listView1);
+      this.splitContainer1.Panel1.Controls.Add(this.contentListView);
       // 
       // splitContainer1.Panel2
       // 
-      this.splitContainer1.Panel2.Controls.Add(this.groupBox1);
-      this.splitContainer1.Size = new System.Drawing.Size(758, 390);
-      this.splitContainer1.SplitterDistance = 252;
+      this.splitContainer1.Panel2.Controls.Add(this.viewHost);
+      this.splitContainer1.Panel2.Controls.Add(this.saveButton);
+      this.splitContainer1.Panel2.Controls.Add(this.tryOutAlgorithmButton);
+      this.splitContainer1.Size = new System.Drawing.Size(838, 449);
+      this.splitContainer1.SplitterDistance = 278;
       this.splitContainer1.TabIndex = 0;
       // 
-      // listView1
+      // contentListView
       // 
-      this.listView1.Location = new System.Drawing.Point(13, 15);
-      this.listView1.Name = "listView1";
-      this.listView1.Size = new System.Drawing.Size(185, 290);
-      this.listView1.TabIndex = 0;
-      this.listView1.UseCompatibleStateImageBehavior = false;
-      this.listView1.SelectedIndexChanged += new System.EventHandler(this.listView1_SelectedIndexChanged);
-      this.listView1.DoubleClick += new System.EventHandler(this.listView1_DoubleClick);
+      this.contentListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.contentListView.Location = new System.Drawing.Point(12, 15);
+      this.contentListView.Name = "contentListView";
+      this.contentListView.Size = new System.Drawing.Size(254, 389);
+      this.contentListView.TabIndex = 0;
+      this.contentListView.UseCompatibleStateImageBehavior = false;
+      this.contentListView.SelectedIndexChanged += new System.EventHandler(this.listView1_SelectedIndexChanged);
+      this.contentListView.DoubleClick += new System.EventHandler(this.listView1_DoubleClick);
       // 
-      // groupBox1
+      // tryOutAlgorithmButton
       // 
-      this.groupBox1.Controls.Add(this.viewHost);
-      this.groupBox1.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.groupBox1.Location = new System.Drawing.Point(0, 0);
-      this.groupBox1.Name = "groupBox1";
-      this.groupBox1.Size = new System.Drawing.Size(502, 390);
-      this.groupBox1.TabIndex = 1;
-      this.groupBox1.TabStop = false;
-      this.groupBox1.Text = "groupBox1";
-      this.groupBox1.Enter += new System.EventHandler(this.groupBox1_Enter);
+      this.tryOutAlgorithmButton.Location = new System.Drawing.Point(443, 410);
+      this.tryOutAlgorithmButton.Name = "tryOutAlgorithmButton";
+      this.tryOutAlgorithmButton.Size = new System.Drawing.Size(97, 23);
+      this.tryOutAlgorithmButton.TabIndex = 2;
+      this.tryOutAlgorithmButton.Text = "Try Out Algorithm";
+      this.tryOutAlgorithmButton.UseVisualStyleBackColor = true;
+      this.tryOutAlgorithmButton.Click += new System.EventHandler(this.tryOutAlgorithmButton_Click);
+      // 
+      // saveButton
+      // 
+      this.saveButton.Location = new System.Drawing.Point(343, 410);
+      this.saveButton.Name = "saveButton";
+      this.saveButton.Size = new System.Drawing.Size(75, 23);
+      this.saveButton.TabIndex = 3;
+      this.saveButton.Text = "Save";
+      this.saveButton.UseVisualStyleBackColor = true;
       // 
       // viewHost
@@ -82,9 +94,9 @@
       this.viewHost.Content = null;
       this.viewHost.Enabled = false;
-      this.viewHost.Location = new System.Drawing.Point(6, 19);
+      this.viewHost.Location = new System.Drawing.Point(14, 15);
       this.viewHost.Name = "viewHost";
       this.viewHost.ReadOnly = false;
-      this.viewHost.Size = new System.Drawing.Size(490, 365);
-      this.viewHost.TabIndex = 0;
+      this.viewHost.Size = new System.Drawing.Size(526, 389);
+      this.viewHost.TabIndex = 4;
       this.viewHost.ViewsLabelVisible = true;
       this.viewHost.ViewType = null;
@@ -96,10 +108,9 @@
       this.Controls.Add(this.splitContainer1);
       this.Name = "DataPreprocessingView";
-      this.Size = new System.Drawing.Size(758, 390);
+      this.Size = new System.Drawing.Size(838, 449);
       this.splitContainer1.Panel1.ResumeLayout(false);
       this.splitContainer1.Panel2.ResumeLayout(false);
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer1)).EndInit();
       this.splitContainer1.ResumeLayout(false);
-      this.groupBox1.ResumeLayout(false);
       this.ResumeLayout(false);
 
@@ -109,7 +120,8 @@
 
     private System.Windows.Forms.SplitContainer splitContainer1;
-    private System.Windows.Forms.ListView listView1;
-    private System.Windows.Forms.GroupBox groupBox1;
-    protected MainForm.WindowsForms.ViewHost viewHost;
+    private System.Windows.Forms.ListView contentListView;
+    private System.Windows.Forms.Button saveButton;
+    private System.Windows.Forms.Button tryOutAlgorithmButton;
+    private MainForm.WindowsForms.ViewHost viewHost;
 
   }